/**************************************************************************

    Copyright (C) 2010  Eli Lilly and Company

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************/

#ifndef _GPU_HAYSTACK_SPREAD_H
#define _GPU_HAYSTACK_SPREAD_H

#include "gpu_haystack.h"


// GPU_Haystack for Spread algorithm
//

class GPU_Haystack_Spread : public GPU_Haystack 
{
  protected:
    int * _d_nsn; //index of nearest neighbour for each molecule
    float * _d_min_dis;//min distance between each molecule and already selected molecules

    void clear();

  private: //disable copy
    GPU_Haystack_Spread( const GPU_Haystack_Spread &);
    GPU_Haystack_Spread& operator=(const GPU_Haystack_Spread &);

  public:
    GPU_Haystack_Spread();
    ~GPU_Haystack_Spread();
    
    int init(Fingerprint * pool, int pool_size);
    
    void do_previously_selected(GPU_Needle & needle,int idx);

    int furthest_from_already_selected(int & offset,int &idx, int & nsn, float & dis );
    void do_spread(int offset,int idx);

    int squeeze();

};


#endif
