/**************************************************************************

    Copyright (C) 2010  Eli Lilly and Company

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************/


#include "gpu_needle.h"

void GPU_Needle::clear()
{
  if(_max_words>0)
  {
    free_gpu(_d_needle);
  }
}

GPU_Needle::GPU_Needle() : _d_needle(0),_max_words(0),_words(0)
{
}

GPU_Needle::~GPU_Needle()
{
  clear();
}

int GPU_Needle::init(Fingerprint & fp )
{
  if(!fp.valid())
  {
   cerr << "Fingerprint is not properly initilized! "<<endl;
   return 0;
  }
  _words=fp.words();
  if(_words > _max_words)
  {
    clear();
    _max_words=_words*2;
    _d_needle=(unsigned int *)malloc_gpu(_max_words*sizeof(unsigned int));
  }
  cpu_to_gpu(_d_needle,fp.get_ptr(),_words*sizeof(unsigned int),0);
  return 1;
}


