/**************************************************************************

    Copyright (C) 2010  Eli Lilly and Company

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************/

#ifndef _GPU_NEEDLE_H
#define _GPU_NEEDLE_H

#include "fingerprint.h"
#include "gpu_functions.h"


//object that store one Fingerprint on GPU 
//GPU_Needle::_d_needle is the same as Fingerprint::_needle
//
class GPU_Needle
{
  protected:
    unsigned int *_d_needle; //data on GPU
    int _max_words; // max length of _d_needle
    int _words; //real data length on _d_needle

    void clear();

  private: //disable copy
    GPU_Needle(const GPU_Needle &);
    GPU_Needle& operator=(const GPU_Needle &);

  public:
    GPU_Needle();
    ~GPU_Needle();

    int init(Fingerprint & fp);

    int words(){return _words;}
    unsigned int * get_ptr(){return _d_needle;}
};


#endif

